﻿using UnityEngine;
using System.Collections;

public class BoundaryManager : MonoBehaviour {
	public GameObject levelManager;	// the object which contains the UnitMapper
	public float boundaryScale;	// how much bigger than the screen should the boundary be

	void Start() {
		print ("BoundaryManager.Start");
	}


	void Update () {
		UnitMapper unitMapper = levelManager.GetComponent<UnitMapper>();

		Vector3 scale = unitMapper.screenSize * boundaryScale;
		scale.z = 10.0f;
		transform.localScale = scale;
		transform.position = unitMapper.screenCenter;
	}

	void OnTriggerExit(Collider other) {
//		print ("BoundaryManager.OnTriggerExit");
		if(other.gameObject.tag.Contains("Token")) {
			Destroy(other.gameObject);
		}
	}
	

}
