﻿using UnityEngine;
using System.Collections;

public class PlayerMove : MonoBehaviour {
	public float moveSpeed = 100;
	public float rotSpeed;
	public float size = 0.1f;
	public LevelManager levelManager;
	public Vector3 velocityVector;

	void Start() {
		transform.position = new Vector3(0.0f, 0.0f, 0.0f);
	}

	void Update() {
		transform.localScale = new Vector3(size, size, size);
	}

	void FixedUpdate () {
		if(levelManager.isAlive == false) return;

		Vector3 pz = Camera.main.ScreenToWorldPoint(Input.mousePosition);
		pz.z = 0;
		rigidbody.AddForce ((pz - transform.position) * moveSpeed);	//Vector2.MoveTowards(transform.position, pz, maxSpeed);

		float torque = (transform.localRotation.eulerAngles.z - 180.0f) * rotSpeed;
		rigidbody.AddTorque(0.0f, 0.0f, torque);

		velocityVector = rigidbody.velocity;
	}

}
