﻿using UnityEngine;
using System.Collections;

public class SideWinder : MonoBehaviour {

	public float minSpeedX = -1.0f;
	public float maxSpeedX =  1.0f;
	public float minSpeedY = -1.0f;
	public float maxSpeedY =  1.0f;
	public float heightOffsetRange = 20.0f;

	private float speedX = 10.0f;
	private float phaseX = 0.0f;
	private float speedY = 10.0f;
	private float phaseY = 0.0f;


	private float heightOffset = 0.0f;
	private float baseY;

	private UnitMapper unitMapper;
	private float timeOfCreation = 0;

	// Use this for initialization
	void Start () {

		speedX = Random.Range (minSpeedX, maxSpeedX);
		phaseX = Random.Range (0.0f, Mathf.PI * 2.0f);

		speedY = Random.Range (minSpeedY, maxSpeedY);
		phaseY = 0;//Random.Range (0.0f, Mathf.PI * 2.0f);

		heightOffset = Random.Range (0.0f, heightOffsetRange);
		unitMapper = GameObject.Find ("LevelManager").GetComponent <LevelManager>().GetComponent<UnitMapper> ();

		timeOfCreation = Time.time;
		baseY = transform.localPosition.y;
	}
	
	// Update is called once per frame
	void Update () {
		float screenWidth = unitMapper.screenSize.x;
		Vector3 pos = transform.localPosition;

		// module x
		pos.x = Mathf.Sin (Time.time * speedX + phaseX) * 0.5f * screenWidth;

		// module y
		// hack to save baseY
		if(heightOffsetRange > 0) {
//			float waitTimeBeforeY  = 0.5f;
//			if(Time.time - timeOfCreation < waitTimeBeforeY) {
//			} else {
				pos.y = Mathf.Sin (Time.time * speedY) * 0.5f * heightOffset + baseY;
//			}
		}
		transform.localPosition = pos;
	}
}
