﻿/*
 * Generators tokens 
 * 
 * 
 */

using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class TokenGenerator : MonoBehaviour {
	public float size;
	public GameObject[] tokenObjects;
	
	public Dictionary<char, GameObject> tokenMappings = new Dictionary<char, GameObject>();	// maps letter to game object
	public List<char> keys;

//	private UnitMapper cellSizeunitMapper;

	// generate the tokens 
	// levelData: the input array of strings
	// startRow / endRow : process these rows (including startRow, excluding endRow)
	// unitMapper: use this for mapping to world
	// offsetRows: how many rows on screen to offset by
	public void generate(string[] levelData, int startRow, int endRow, UnitMapper unitMapper, float yoffset) {
//		print ("TokenGenerator.generate " + startRow + " - " + endRow);
//		Vector2 cellCount = unitMapper.cellCount;

//		int startRow = 0;
//		int endRow = levelData.Length;

		// iterate relevant rows to generate
		for(int j=startRow; j<endRow; j++) {
			string s = levelData[j];
//			print (s);

			// iterate chars (limited by cellCount and length of string)
//			int numChars = (int)Mathf.Min(cellCount.x, s.Length);
			for(int i=0; i<s.Length; i++) {
				char c = s[i];	// read character

				// if we know what to do with this charater.
				if(tokenMappings.ContainsKey(c)) {
					GameObject go = tokenMappings[c];
//					print ("Creating " + c);
					Vector3 pos = unitMapper.cellToWorldPoint(new Vector2(i, j));
					pos.y += yoffset;
					GameObject instance = (GameObject)Instantiate(go, pos, Quaternion.identity);
//					instance.transform.position = ;
					instance.transform.parent = transform;
					float scale = unitMapper.cellSize.x * size;
					instance.transform.localScale = new Vector3(scale, scale, scale);
				} else {
//					print ("Object '" + c + "' not found");
				}
			}
		}
	}


	// Use this for initialization
	void Start () {
		print ("TokenGenerator.Start");

//		unitMapper = gameObject.GetComponent<UnitMapper>();

		// generate token mappings dictionary
		// EVERYTHING IN UPPERCASE
		for (int i=0; i<tokenObjects.Length; i++) {
			GameObject go = tokenObjects[i];
			if(go) tokenMappings[go.name.ToUpper()[0]] = go;
		}

		keys = new List<char>(tokenMappings.Keys);
	}

}
