﻿using UnityEngine;
using System.Collections;

public class TokenManager : MonoBehaviour {
	public float collisionSpeed = 100.0f;

	private LevelManager levelManager;
	// Use this for initialization
	void Start () {
		levelManager = GameObject.Find("/LevelManager").GetComponent<LevelManager>();
	
	}


	void OnTriggerEnter(Collider other) {
		//		print ("COLLISION");

		bool isParrot = other.gameObject.CompareTag("Parrot");
		bool isPlayer = other.gameObject.CompareTag("Player");
		bool isEither = isParrot || isPlayer;

		// if hit killer token...
		if(gameObject.CompareTag("KillerToken")) {
			// add force

			if(isEither)  {
				audio.Play();
				rigidbody.isKinematic = false;
				rigidbody.AddForce(other.rigidbody.velocity * collisionSpeed);
				rigidbody.AddTorque(0.0f, 0.0f, 1000.0f * Random.Range(-1.0f, 1.0f));

				if(isParrot) {
//					print("isParrot");

					other.gameObject.GetComponent<ParrotManager>().doBite();
				}
			}

			if(isPlayer) {
				float mt = 10000.0f;
				other.rigidbody.AddTorque(0.0f, 0.0f, mt * Random.Range (-1.0f, 1.0f));
				levelManager.hitKill();
				//yield return new WaitForSeconds(2);
				//levelManager.reset ();
			}

		// else hit slower token
		} else if(gameObject.CompareTag("SlowerToken")) {

			if(isEither)  {
				audio.Play();

				Destroy(gameObject);
				if(isParrot) {
//					print("isParrot");
					other.gameObject.GetComponent<ParrotManager>().doBite();
				}
			}

			if(isPlayer) {
				levelManager.hitSlowdown();
			}
		}
	}
}
