﻿using UnityEngine;
using System.Collections;

public class UnitMapper : MonoBehaviour {
	public Vector2 cellCount = new Vector2(11, 0);	// how many cells per screen
	public Vector3 screenSize;		// size of on screen world in world units
	public Vector3 screenCenter;	// center of screen in world units
	public Vector2 cellSize;		// size of one cell in world units


	// TODO: check
	public Vector2 worldToCellPoint(Vector3 worldPos) {
		Vector3 scrPos = worldPos - screenCenter +  (screenSize * 0.5f);
		scrPos.Scale (new Vector3(1.0f/cellSize.x, 1.0f/cellSize.y, 1.0f));

		return new Vector2(scrPos.x + 0.5f, cellCount.y - 0.5f - scrPos.y);
	}
	
	public Vector3 cellToWorldPoint(Vector2 cellPos) {
		Vector3 scrPos = new Vector3(cellPos.x + 0.5f, cellCount.y - 0.5f - cellPos.y, 0);
		scrPos.Scale (cellSize);
		scrPos += screenCenter - (screenSize * 0.5f);
//		scrPos -= screenCenter * 0.5f - screenCenter;
//		Vector3 ret = Camera.main.ScreenToWorldPoint(scrPos);
//		ret.z = 0;
		return scrPos;
	}
	
	
	// Use this for initialization
	void Start () {
		print ("UnitMapper.Start");

		// set camera scale so 1 unit = 1 pixel
//		Camera.main.orthographicSize = Screen.height / 2.0f;
//		Camera.main.transform.position = new Vector3(Screen.width/2, Screen.height/2, -100);

//		screenSize = new Vector3(Screen.width, Screen.height, 10);
//		screenCenter = new Vector3(Camera.main.transform.position.x, Camera.main.transform.position.y, 0);
		Update();
	}

	// Update is called once per frame
	void Update () {
		Vector3 bl = Camera.main.ScreenToWorldPoint (new Vector3 (0, 0, 0));
		Vector3 tr = Camera.main.ScreenToWorldPoint (new Vector3 (Screen.width, Screen.height, 0));
		screenSize = (tr - bl);	// screen size in world unis
		screenCenter = (tr + bl) * 0.5f;	// screen center in world units
		screenCenter.z = 0;
		cellSize.x =  screenSize.x / (float)cellCount.x;	// size of one cell in world units
		cellSize.y = cellSize.x;
		cellCount.y = (int)Mathf.Ceil(screenSize.y / cellSize.y);
	}
}
